function [pos,theta,M,Mu]=magnetic(particleNum,dim_nc,surfactant,dim,A_h,pos,movement,theta,rotation,Kd,Ka,Kz,K_steric,M,Mu,H,T)

   k=1.3806488*10^(-23); 

  A=@(x,y,z) [cos(y)*cos(z),-cos(y)*sin(z),-sin(y);...
      cos(x)*sin(z)-sin(x)*sin(y)*cos(z),sin(x)*sin(y)*sin(z)+cos(x)*cos(z),-sin(x)*cos(y);...
      cos(x)*sin(y)*cos(z)+sin(x)*sin(z),sin(x)*cos(z)-cos(x)*sin(y)*sin(z),cos(x)*cos(y)];
  
  B=@(x,y,z) [cos(y)*cos(z),-cos(x)*sin(z)-sin(x)*sin(y)*cos(z),sin(x)*sin(z)-cos(x)*sin(y)*cos(z);...
      cos(y)*sin(z),cos(x)*cos(z)-sin(x)*sin(y)*sin(z),-sin(x)*cos(z)-cos(x)*sin(y)*sin(z);...
      sin(y),sin(x)*cos(y),cos(x)*cos(y)];
   
  
   
   
   cutOff=200; %nm distance beyond which potentials are not considered
   
    for i=1:particleNum
        
        Edd(1:2)=0;
        
        pos(i,:)=pos(i,:)+movement(i,:);
        theta(i,:)=theta(i,:)+rotation(i,:);
        M(i,:)=(A(theta(i,1),theta(i,2),theta(i,3))*Mu(i,:)')';
        
        mat=pos;
        nat(1:particleNum,1)=pos(i,1);
        nat(1:particleNum,2)=pos(i,2);
        nat(1:particleNum,3)=pos(i,3);
        
        r=mat-nat;
        r_dist=sqrt(r(:,1).^2+r(:,2).^2+r(:,3).^2);
        r_overl=[r_dist,[1:particleNum]'];
        r(i,:)=[];
        r_dist(i)=[];
        r_overl(i,:)=[];
        L=find(r_dist<cutOff);
        r_dist=r_dist(L);
        r=r(L,:);
        l=length(r(:,1));
        
        Mj=M;
        Mi=Mj(i,:);
        Mi0=(A(theta(i,1)-rotation(i,1),theta(i,2)-rotation(i,2),theta(i,3)-rotation(i,3))*Mu(i,:)')';
        Mj(i,:)=[];
       
        Mu0=(B(-theta(i,1),-theta(i,2),-theta(i,3))*Mi0')';
        
        rot=theta;
        rot(i,:)=rot(i,:)-rotation(i,:);
        
     
                
%         H_nc=0;
%         
%         for j=1:l
%             H_nc=H_nc+Kh*(3*(Mj(j,:)*r(j,:)')*r(j,:)/(r(j,:)*r(j,:)')^(5/2)-Mj(j,:)/(r(j,:)*r(j,:)')^(3/2));
%         end
%       
%         Heff=H+H_nc/sqrt(H_nc*H_nc');
%         Heff=Heff/sqrt(Heff*Heff');
%         
%         Heffu=(A(-theta(i))*Heff')'; 
        

%      %superparamagnetism
%         
%         Eb=Ka*((-Mu(i,1)*(-Mu(i,2)))^2+((-Mu(i,1))*(-Mu(i,3)))^2+((-Mu(i,2))*(-Mu(i,3)))^2)-(Kz*M(i,:)*H'-ms*M(i,:)*H_nc')-(Ka*((Mu(i,1)*Mu(i,2))^2+(Mu(i,1)*Mu(i,3))^2+(Mu(i,2)*Mu(i,3))^2)+Kz*M(i,:)*H'-ms*M(i,:)*H_nc');
% 
% %         Eb=[(Ka*(Heffu(1)*Heffu(2))^2+(Kz*Heff*H'-ms*Heff*H_nc')-(Ka*(Mu(i,1)*Mu(i,2))^2+Kz*M(i,:)*H'-ms*M(i,:)*H_nc')),(Ka*(-Heffu(1)*(-Heffu(2)))^2-(Kz*Heff*H'-ms*Heff*H_nc')-(Ka*(Mu(i,1)*Mu(i,2))^2+Kz*M(i,:)*H'-ms*M(i,:)*H_nc'))];
% %       
% %         ol=find(abs(Eb)==max(abs(Eb)));
% %         
% %         Eb=Eb(ol);
%         
%           
%         if Eb<0
%             tau_spm=tau_0;
%             
%         else
%             tau_spm=tau_0*exp(Eb/(k*T));
%             
%         end
%         
%         P_trans=1-exp(-tau/tau_spm);
%         
%         if rand<=P_trans
%             M(i,:)=-M(i,:);
%             Mu(i,:)=-Mu(i,:);
%             u_rotation(i)=u_rotation(i)+pi;
%         end
%             
%             
% %         if rand<=P_trans
% %             if ol==1
% %                 u_rotation(i)=u_rotation(i)+acos(Mu(i,:)*Heffu');
% %                 M(i,:)=Heff;
% %                 Mu(i,:)=Heffu;
% %             elseif ol==2
% %                 u_rotation(i)=u_rotation(i)+acos(Mu(i,:)*(-Heffu)');
% %                 M(i,:)=-Heff;
% %                 Mu(i,:)=-Heffu;
% %             end
% %         end
              
        

        %% determining orientation (only angle-dependent terms)
        
        Er0=0;
        Ea0=0;
        Ea=0;
        vdW=0;
        %H_nc=0;
        anisotropy=false;
        
        
        for j=1:l
            
            Ea0=Ea0+Kd*0.5*(Mi0*Mj(j,:)'/r_dist(j)^3 - 3*(Mi0*r(j,:)')*(Mj(j,:)*r(j,:)')/r_dist(j)^5); %no rotation of moment
                
     
            Ea=Ea+Kd*0.5*(Mi*Mj(j,:)'/r_dist(j)^3 - 3*(Mi*r(j,:)')*(Mj(j,:)*r(j,:)')/r_dist(j)^5); %rotated moment
            
            
            vdW=vdW-A_h*0.5*dim_nc^2/(12*pi)*(1/(r_dist(j)-dim_nc)^2+1/(r_dist(j)+dim_nc)^2-2/r_dist(j)^2); %vdW interactions after movement of cube i
            
            
           % H_nc=H_nc+Kh*(3*(Mj(j,:)*r(j,:)')*r(j,:)/(r(j,:)*r(j,:)')^(5/2)-Mj(j,:)/(r(j,:)*r(j,:)')^(3/2));
               
        end
        
        
        dipole1=Ea0;
        dipole2=Ea;
        
        dim_nc_tot1=totDim(dim_nc,surfactant,A,theta(i,:)-rotation(i,:));
        dim_nc_tot2=totDim(dim_nc,surfactant,A,theta(i,:));
        
%         wallPotential1=(1/(pos(i,1)-dim_nc_tot1/2)^50+1/(pos(i,1)+dim_nc_tot1/2-dim(1))^50+1/(pos(i,2)-dim_nc_tot1/2)^50+1/(pos(i,2)+dim_nc_tot1/2-dim(2))^50+1/(pos(i,3)-dim_nc_tot1/2)^50+1/(pos(i,3)+dim_nc_tot1/2-dim(3))^50)*10^(-20);
%         wallPotential2=(1/(pos(i,1)-dim_nc_tot2/2)^50+1/(pos(i,1)+dim_nc_tot2/2-dim(1))^50+1/(pos(i,2)-dim_nc_tot2/2)^50+1/(pos(i,2)+dim_nc_tot2/2-dim(2))^50+1/(pos(i,3)-dim_nc_tot2/2)^50+1/(pos(i,3)+dim_nc_tot2/2-dim(3))^50)*10^(-20);
        
        wallPotential1=(1/(1+exp(10*(pos(i,1)-dim_nc_tot1/2)))+1/(1+exp(-10*(pos(i,1)+dim_nc_tot1/2-dim(1))))+1/(1+exp(10*(pos(i,2)-dim_nc_tot1/2)))+1/(1+exp(-10*(pos(i,2)+dim_nc_tot1/2-dim(2))))+1/(1+exp(10*(pos(i,3)-dim_nc_tot1/2)))+0.9/(1+exp(-10*(pos(i,3)+dim_nc_tot1/2-dim(3)))))*10^(-16);
        wallPotential2=(1/(1+exp(10*(pos(i,1)-dim_nc_tot2/2)))+1/(1+exp(-10*(pos(i,1)+dim_nc_tot2/2-dim(1))))+1/(1+exp(10*(pos(i,2)-dim_nc_tot2/2)))+1/(1+exp(-10*(pos(i,2)+dim_nc_tot2/2-dim(2))))+1/(1+exp(10*(pos(i,3)-dim_nc_tot2/2)))+0.9/(1+exp(-10*(pos(i,3)+dim_nc_tot2/2-dim(3)))))*10^(-16);
          
        
        steric1=overlap(i,dim_nc,surfactant,pos,r_overl,rot,K_steric,A);
        steric2=overlap(i,dim_nc,surfactant,pos,r_overl,theta,K_steric,A);
       
        
        Er0=Ea0+Ka*((Mu(i,1)*Mu(i,2))^2+(Mu(i,1)*Mu(i,3))^2+(Mu(i,2)*Mu(i,3))^2)+Kz(pos(i,:)*H')*Mi0*H'+steric1+wallPotential1; %rotating neither cube nor moment
                
        
        Ea0=Ea0+Ka*((Mu0(1)*Mu0(2))^2+(Mu0(1)*Mu0(3))^2+(Mu0(2)*Mu0(3))^2)+Kz(pos(i,:)*H')*Mi0*H'+steric2+wallPotential2; %rotating cube but not moment
        
        
        Ea=Ea+Ka*((Mu(i,1)*Mu(i,2))^2+(Mu(i,1)*Mu(i,3))^2+(Mu(i,2)*Mu(i,3))^2)+ Kz(pos(i,:)*H')*Mi*H'+steric2+wallPotential2; %rotating both cube and moment
  

        
        wallPotential=wallPotential2;
        dim_nc_tot=dim_nc_tot2;
        Edd(1)=steric2;
        dipole=dipole2;
        
        
        
       if Ea0 > Er0

                p = exp(-(Ea0-Er0)/(k*T));

                if rand > p
                     theta(i,:)=theta(i,:)-rotation(i,:);
                     M(i,:)=Mi0;
                     Mi=Mi0;
                     wallPotential=wallPotential1;
                     dim_nc_tot=dim_nc_tot1;
                     Edd(1)=steric1;
                     dipole=dipole1;
                     anisotropy=true;
                end
        end
        
        
        
        
        if anisotropy==false && Ea > Ea0

                p = exp(-(Ea-Ea0)/(k*T));

                if rand > p
                     Mu(i,:)=Mu0;
                     M(i,:)=Mi0;
                     Mi=Mi0;
                     dipole=dipole1;
                     anisotropy=true;
                end
        end
        
        
        if anisotropy==false;
            
            
            if Ea > Er0

                    p = exp(-(Ea-Er0)/(k*T));

                    if rand > p
                         theta(i,:)=theta(i,:)-rotation(i,:);
                         M(i,:)=Mi0;
                         Mi=Mi0;
                         wallPotential=wallPotential1;
                         dim_nc_tot=dim_nc_tot1;
                         dipole=dipole1;
                         Edd(1)=steric1;
                    end
            end
            
        end  
        
        
        
        %% determining position (only position-dependent terms)
         
         Edd(1)=Edd(1)+vdW+dipole+Kz(pos(i,:)*H')*Mi*H'+wallPotential;
         
         
         
                  mat=pos;
                  mat(i,:)=mat(i,:)-movement(i,:);
                  nat(1:particleNum,1)=pos(i,1)-movement(i,1);
                  nat(1:particleNum,2)=pos(i,2)-movement(i,2);
                  nat(1:particleNum,3)=pos(i,3)-movement(i,3);

                  r=mat-nat;
                  r_dist=sqrt(r(:,1).^2+r(:,2).^2+r(:,3).^2);
                  r_overl=[r_dist,[1:particleNum]'];
                  r(i,:)=[];
                  r_dist(i)=[];
                  r_overl(i,:)=[];
                  L=find(r_dist<cutOff);
                  r_dist=r_dist(L);
                  r=r(L,:);
                  l=length(r(:,1));

                  Edd(2)=Edd(2)+overlap(i,dim_nc,surfactant,mat,r_overl,theta,K_steric,A);
                      
                  for j=1:l      
                      Edd(2)=Edd(2)+Kd*0.5*(Mi*Mj(j,:)'/r_dist(j)^3 - 3*(Mi*r(j,:)')*(Mj(j,:)*r(j,:)')/r_dist(j)^5)-...
                          A_h*0.5*dim_nc^2/(12*pi)*(1/(r_dist(j)-dim_nc)^2+1/(r_dist(j)+dim_nc)^2-2/r_dist(j)^2);
                  end
                  
                  Edd(2)=Edd(2)+Kz(mat(i,:)*H')*Mi*H'+...
                      (1/(1+exp(10*(mat(i,1)-dim_nc_tot/2)))+1/(1+exp(-10*(mat(i,1)+dim_nc_tot/2-dim(1))))+1/(1+exp(10*(mat(i,2)-dim_nc_tot/2)))+1/(1+exp(-10*(mat(i,2)+dim_nc_tot/2-dim(2))))+1/(1+exp(10*(mat(i,3)-dim_nc_tot/2)))+0.9/(1+exp(-10*(mat(i,3)+dim_nc_tot/2-dim(3)))))*10^(-16);
%                       (1/(mat(i,1)-dim_nc_tot/2)^50+1/(mat(i,1)+dim_nc_tot/2-dim(1))^50+1/(mat(i,2)-dim_nc_tot/2)^50+1/(mat(i,2)+dim_nc_tot/2-dim(2))^50+1/(mat(i,3)-dim_nc_tot/2)^50+1/(mat(i,3)+dim_nc_tot/2-dim(3))^50)*10^(-20);
         
         
         
         if Edd(1) > Edd(2)

             p = exp(-(Edd(1)-Edd(2))/(k*T));

             if rand > p
                 
                 pos(i,:)=pos(i,:)-movement(i,:);
                    
             end
                
          end
        
    end
        
        
    
end



%% Calculating distance between faces to determine overlap

function [Edd]=overlap(i,dim_nc,surfactant,pos,r_overl,theta,K_steric,A)

Edd=0; 
corners=[-1 -1 -1; -1 1 -1; 1 1 -1; 1 -1 -1; -1 -1 1; -1 1 1; 1 1 1; 1 -1 1]'*dim_nc/2;
 dim_nc_tot=dim_nc+2*surfactant;

 

 L=find(r_overl(:,1)<(dim_nc_tot*sqrt(3)));
 r_overl=r_overl(L,:);
 l=length(r_overl(:,1));

 overl=zeros(l,2);
     
        for j=1:l
            
                    
                    ol=0;
                    o=r_overl(j,2);
               
                    corners1=A(theta(i,1),theta(i,2),theta(i,3))*corners;
                    corners2=A(theta(o,1),theta(o,2),theta(o,3))*corners;

                    corners1(1,:)=corners1(1,:)+pos(i,1);
                    corners1(2,:)=corners1(2,:)+pos(i,2);
                    corners1(3,:)=corners1(3,:)+pos(i,3);

                    corners2(1,:)=corners2(1,:)+pos(o,1);
                    corners2(2,:)=corners2(2,:)+pos(o,2);
                    corners2(3,:)=corners2(3,:)+pos(o,3);

                    corners1=corners1';
                    corners2=corners2';

                    %% axes
                    axis11=corners1(4,:)-corners1(1,:);
                    axis12=corners1(2,:)-corners1(1,:);
                    axis13=corners1(5,:)-corners1(1,:);

                    axis21=corners2(4,:)-corners2(1,:);
                    axis22=corners2(2,:)-corners2(1,:);
                    axis23=corners2(5,:)-corners2(1,:);

                    uaxis11=axis11/sqrt(axis11*axis11');
                    uaxis12=axis12/sqrt(axis12*axis12');
                    uaxis13=axis13/sqrt(axis13*axis13');
                    uaxis21=axis21/sqrt(axis21*axis21');
                    uaxis22=axis22/sqrt(axis22*axis22');
                    uaxis23=axis23/sqrt(axis23*axis23');


                    diagonal11=corners1(7,:)-corners1(1,:);
                    diagonal12=corners1(8,:)-corners1(2,:);
                    diagonal13=corners1(5,:)-corners1(3,:);
                    diagonal14=corners1(6,:)-corners1(4,:);

                    diagonal21=corners2(7,:)-corners2(1,:);
                    diagonal22=corners2(8,:)-corners2(2,:);
                    diagonal23=corners2(5,:)-corners2(3,:);
                    diagonal24=corners2(6,:)-corners2(4,:);


                    %% projection onto axis1 on cube1
                    proj1=abs(uaxis11*diagonal21');
                    proj2=abs(uaxis11*diagonal22');
                    proj3=abs(uaxis11*diagonal23');
                    proj4=abs(uaxis11*diagonal24');

                    proj=[proj1,proj2,proj3,proj4];

                    diagonal=find(proj==max(proj));
                    diagonal=diagonal(1);

                    proj=max(proj);


                    limit=sqrt(axis11*axis11')+proj;


                    if diagonal==1
                        proj1=abs(uaxis11*(corners1(1,:)-corners2(1,:))');
                        proj2=abs(uaxis11*(corners1(1,:)-corners2(7,:))');
                        proj3=abs(uaxis11*(corners1(4,:)-corners2(1,:))');
                        proj4=abs(uaxis11*(corners1(4,:)-corners2(7,:))');

                        proj=max([proj1,proj2,proj3,proj4]);

                    elseif diagonal==2
                        proj1=abs(uaxis11*(corners1(1,:)-corners2(2,:))');
                        proj2=abs(uaxis11*(corners1(1,:)-corners2(8,:))');
                        proj3=abs(uaxis11*(corners1(4,:)-corners2(2,:))');
                        proj4=abs(uaxis11*(corners1(4,:)-corners2(8,:))');

                        proj=max([proj1,proj2,proj3,proj4]);

                    elseif diagonal==3
                        proj1=abs(uaxis11*(corners1(1,:)-corners2(5,:))');
                        proj2=abs(uaxis11*(corners1(1,:)-corners2(3,:))');
                        proj3=abs(uaxis11*(corners1(4,:)-corners2(5,:))');
                        proj4=abs(uaxis11*(corners1(4,:)-corners2(3,:))');

                        proj=max([proj1,proj2,proj3,proj4]);

                    elseif diagonal==4
                        proj1=abs(uaxis11*(corners1(1,:)-corners2(6,:))');
                        proj2=abs(uaxis11*(corners1(1,:)-corners2(4,:))');
                        proj3=abs(uaxis11*(corners1(4,:)-corners2(6,:))');
                        proj4=abs(uaxis11*(corners1(4,:)-corners2(4,:))');

                        proj=max([proj1,proj2,proj3,proj4]);

                    end

                    if proj>limit
                        ol(1)=proj-limit;
                    end


                    %% projection onto axis2 on cube1
                    proj1=abs(uaxis12*diagonal21');
                    proj2=abs(uaxis12*diagonal22');
                    proj3=abs(uaxis12*diagonal23');
                    proj4=abs(uaxis12*diagonal24');

                    proj=[proj1,proj2,proj3,proj4];

                    diagonal=find(proj==max(proj));
                    diagonal=diagonal(1);

                    proj=max(proj);


                    limit=sqrt(axis12*axis12')+proj;


                    if diagonal==1
                        proj1=abs(uaxis12*(corners1(1,:)-corners2(1,:))');
                        proj2=abs(uaxis12*(corners1(1,:)-corners2(7,:))');
                        proj3=abs(uaxis12*(corners1(2,:)-corners2(1,:))');
                        proj4=abs(uaxis12*(corners1(2,:)-corners2(7,:))');

                        proj=max([proj1,proj2,proj3,proj4]);

                    elseif diagonal==2
                        proj1=abs(uaxis12*(corners1(1,:)-corners2(2,:))');
                        proj2=abs(uaxis12*(corners1(1,:)-corners2(8,:))');
                        proj3=abs(uaxis12*(corners1(2,:)-corners2(2,:))');
                        proj4=abs(uaxis12*(corners1(2,:)-corners2(8,:))');

                        proj=max([proj1,proj2,proj3,proj4]);

                    elseif diagonal==3
                        proj1=abs(uaxis12*(corners1(1,:)-corners2(5,:))');
                        proj2=abs(uaxis12*(corners1(1,:)-corners2(3,:))');
                        proj3=abs(uaxis12*(corners1(2,:)-corners2(5,:))');
                        proj4=abs(uaxis12*(corners1(2,:)-corners2(3,:))');

                        proj=max([proj1,proj2,proj3,proj4]);

                    elseif diagonal==4
                        proj1=abs(uaxis12*(corners1(1,:)-corners2(6,:))');
                        proj2=abs(uaxis12*(corners1(1,:)-corners2(4,:))');
                        proj3=abs(uaxis12*(corners1(2,:)-corners2(6,:))');
                        proj4=abs(uaxis12*(corners1(2,:)-corners2(4,:))');

                        proj=max([proj1,proj2,proj3,proj4]);

                    end

                    if proj>limit
                        ol(2)=proj-limit;
                    end



                    %% projection onto axis3 on cube1
                    proj1=abs(uaxis13*diagonal21');
                    proj2=abs(uaxis13*diagonal22');
                    proj3=abs(uaxis13*diagonal23');
                    proj4=abs(uaxis13*diagonal24');

                    proj=[proj1,proj2,proj3,proj4];

                    diagonal=find(proj==max(proj));
                    diagonal=diagonal(1);

                    proj=max(proj);


                    limit=sqrt(axis13*axis13')+proj;


                    if diagonal==1
                        proj1=abs(uaxis13*(corners1(1,:)-corners2(1,:))');
                        proj2=abs(uaxis13*(corners1(1,:)-corners2(7,:))');
                        proj3=abs(uaxis13*(corners1(5,:)-corners2(1,:))');
                        proj4=abs(uaxis13*(corners1(5,:)-corners2(7,:))');

                        proj=max([proj1,proj2,proj3,proj4]);

                    elseif diagonal==2
                        proj1=abs(uaxis13*(corners1(1,:)-corners2(2,:))');
                        proj2=abs(uaxis13*(corners1(1,:)-corners2(8,:))');
                        proj3=abs(uaxis13*(corners1(5,:)-corners2(2,:))');
                        proj4=abs(uaxis13*(corners1(5,:)-corners2(8,:))');

                        proj=max([proj1,proj2,proj3,proj4]);

                    elseif diagonal==3
                        proj1=abs(uaxis13*(corners1(1,:)-corners2(5,:))');
                        proj2=abs(uaxis13*(corners1(1,:)-corners2(3,:))');
                        proj3=abs(uaxis13*(corners1(5,:)-corners2(5,:))');
                        proj4=abs(uaxis13*(corners1(5,:)-corners2(3,:))');

                        proj=max([proj1,proj2,proj3,proj4]);

                    elseif diagonal==4
                        proj1=abs(uaxis13*(corners1(1,:)-corners2(6,:))');
                        proj2=abs(uaxis13*(corners1(1,:)-corners2(4,:))');
                        proj3=abs(uaxis13*(corners1(5,:)-corners2(6,:))');
                        proj4=abs(uaxis13*(corners1(5,:)-corners2(4,:))');

                        proj=max([proj1,proj2,proj3,proj4]);

                    end

                    if proj>limit
                        ol(3)=proj-limit;
                    end


                    %% projection onto axis1 on cube2
                    proj1=abs(uaxis21*diagonal11');
                    proj2=abs(uaxis21*diagonal12');
                    proj3=abs(uaxis21*diagonal13');
                    proj4=abs(uaxis21*diagonal14');

                    proj=[proj1,proj2,proj3,proj4];

                    diagonal=find(proj==max(proj));
                    diagonal=diagonal(1);

                    proj=max(proj);


                    limit=sqrt(axis21*axis21')+proj;


                    if diagonal==1
                        proj1=abs(uaxis21*(corners2(1,:)-corners1(1,:))');
                        proj2=abs(uaxis21*(corners2(1,:)-corners1(7,:))');
                        proj3=abs(uaxis21*(corners2(4,:)-corners1(1,:))');
                        proj4=abs(uaxis21*(corners2(4,:)-corners1(7,:))');

                        proj=max([proj1,proj2,proj3,proj4]);

                    elseif diagonal==2
                        proj1=abs(uaxis21*(corners2(1,:)-corners1(2,:))');
                        proj2=abs(uaxis21*(corners2(1,:)-corners1(8,:))');
                        proj3=abs(uaxis21*(corners2(4,:)-corners1(2,:))');
                        proj4=abs(uaxis21*(corners2(4,:)-corners1(8,:))');

                        proj=max([proj1,proj2,proj3,proj4]);

                    elseif diagonal==3
                        proj1=abs(uaxis21*(corners2(1,:)-corners1(5,:))');
                        proj2=abs(uaxis21*(corners2(1,:)-corners1(3,:))');
                        proj3=abs(uaxis21*(corners2(4,:)-corners1(5,:))');
                        proj4=abs(uaxis21*(corners2(4,:)-corners1(3,:))');

                        proj=max([proj1,proj2,proj3,proj4]);

                    elseif diagonal==4
                        proj1=abs(uaxis21*(corners2(1,:)-corners1(6,:))');
                        proj2=abs(uaxis21*(corners2(1,:)-corners1(4,:))');
                        proj3=abs(uaxis21*(corners2(4,:)-corners1(6,:))');
                        proj4=abs(uaxis21*(corners2(4,:)-corners1(4,:))');

                        proj=max([proj1,proj2,proj3,proj4]);

                    end

                    if proj>limit
                        ol(4)=proj-limit;
                    end


                    %% projection onto axis2 on cube2
                    proj1=abs(uaxis22*diagonal11');
                    proj2=abs(uaxis22*diagonal12');
                    proj3=abs(uaxis22*diagonal13');
                    proj4=abs(uaxis22*diagonal14');

                    proj=[proj1,proj2,proj3,proj4];

                    diagonal=find(proj==max(proj));
                    diagonal=diagonal(1);

                    proj=max(proj);


                    limit=sqrt(axis22*axis22')+proj;


                    if diagonal==1
                        proj1=abs(uaxis22*(corners2(1,:)-corners1(1,:))');
                        proj2=abs(uaxis22*(corners2(1,:)-corners1(7,:))');
                        proj3=abs(uaxis22*(corners2(2,:)-corners1(1,:))');
                        proj4=abs(uaxis22*(corners2(2,:)-corners1(7,:))');

                        proj=max([proj1,proj2,proj3,proj4]);

                    elseif diagonal==2
                        proj1=abs(uaxis22*(corners2(1,:)-corners1(2,:))');
                        proj2=abs(uaxis22*(corners2(1,:)-corners1(8,:))');
                        proj3=abs(uaxis22*(corners2(2,:)-corners1(2,:))');
                        proj4=abs(uaxis22*(corners2(2,:)-corners1(8,:))');

                        proj=max([proj1,proj2,proj3,proj4]);

                    elseif diagonal==3
                        proj1=abs(uaxis22*(corners2(1,:)-corners1(5,:))');
                        proj2=abs(uaxis22*(corners2(1,:)-corners1(3,:))');
                        proj3=abs(uaxis22*(corners2(2,:)-corners1(5,:))');
                        proj4=abs(uaxis22*(corners2(2,:)-corners1(3,:))');

                        proj=max([proj1,proj2,proj3,proj4]);

                    elseif diagonal==4
                        proj1=abs(uaxis22*(corners2(1,:)-corners1(6,:))');
                        proj2=abs(uaxis22*(corners2(1,:)-corners1(4,:))');
                        proj3=abs(uaxis22*(corners2(2,:)-corners1(6,:))');
                        proj4=abs(uaxis22*(corners2(2,:)-corners1(4,:))');

                        proj=max([proj1,proj2,proj3,proj4]);

                    end

                    if proj>limit
                        ol(5)=proj-limit;
                    end


                    %% projection onto axis3 on cube2
                    proj1=abs(uaxis23*diagonal11');
                    proj2=abs(uaxis23*diagonal12');
                    proj3=abs(uaxis23*diagonal13');
                    proj4=abs(uaxis23*diagonal14');

                    proj=[proj1,proj2,proj3,proj4];

                    diagonal=find(proj==max(proj));
                    diagonal=diagonal(1);

                    proj=max(proj);


                    limit=sqrt(axis23*axis23')+proj;


                    if diagonal==1
                        proj1=abs(uaxis23*(corners2(1,:)-corners1(1,:))');
                        proj2=abs(uaxis23*(corners2(1,:)-corners1(7,:))');
                        proj3=abs(uaxis23*(corners2(5,:)-corners1(1,:))');
                        proj4=abs(uaxis23*(corners2(5,:)-corners1(7,:))');

                        proj=max([proj1,proj2,proj3,proj4]);

                    elseif diagonal==2
                        proj1=abs(uaxis23*(corners2(1,:)-corners1(2,:))');
                        proj2=abs(uaxis23*(corners2(1,:)-corners1(8,:))');
                        proj3=abs(uaxis23*(corners2(5,:)-corners1(2,:))');
                        proj4=abs(uaxis23*(corners2(5,:)-corners1(8,:))');

                        proj=max([proj1,proj2,proj3,proj4]);

                    elseif diagonal==3
                        proj1=abs(uaxis23*(corners2(1,:)-corners1(5,:))');
                        proj2=abs(uaxis23*(corners2(1,:)-corners1(3,:))');
                        proj3=abs(uaxis23*(corners2(5,:)-corners1(5,:))');
                        proj4=abs(uaxis23*(corners2(5,:)-corners1(3,:))');

                        proj=max([proj1,proj2,proj3,proj4]);

                    elseif diagonal==4
                        proj1=abs(uaxis23*(corners2(1,:)-corners1(6,:))');
                        proj2=abs(uaxis23*(corners2(1,:)-corners1(4,:))');
                        proj3=abs(uaxis23*(corners2(5,:)-corners1(6,:))');
                        proj4=abs(uaxis23*(corners2(5,:)-corners1(4,:))');

                        proj=max([proj1,proj2,proj3,proj4]);

                    end

                    if proj>limit
                        ol(6)=proj-limit;
                    end  
                             
                overl(j,1)=max(ol);
                
                if overl(j,1)<surfactant
                    overl(j,2)=2;
                else
                    overl(j,2)=1;
                end
              
              
                
       end
   
     overl(overl(:,1)>2*surfactant)=0;
     index=find(overl(:,1)==0);
     overl(index,:)=[];
     
     if isempty(overl)==true
         return
     end
    

     l=length(overl(:,1));
     
     K_steric=K_steric*0.5; %factor of 0.5 to account for double counting
     
     for j=1:l
        
         if overl(j,2)==1
             Edd=Edd+K_steric(1)*(overl(j,1)-2*surfactant)^2;
         else
             Edd=Edd+K_steric(2)*(3*log(surfactant/overl(j,1))+2*overl(j,1)/surfactant-3/2)+...
                 K_steric(3)*(overl(j,1)*(log(surfactant/overl(j,1))-1)+surfactant);
         end
                
     end
     
    
end



%% Finding the corrected (total) dimensions of the cube

function [dim_nc_tot]=totDim(dim_nc,surfactant,A,theta)
      
        vertex=[-1,1;-1,1;-1,1]*(dim_nc+2*surfactant)/2;
           
        vertex=A(theta(1),theta(2),theta(3))*vertex;
        
        vertex=abs(vertex);
        vertex=vertex(:,1)+vertex(:,2);
           
        dim_nc_tot=max(vertex);


end
