function [pos,theta]=stericRepulsion(ncLabel_1,ncLabel_2,dim_nc_tot,movement,validate,s,pos,theta)

 A=@(x,y,z) [cos(y)*cos(z),-cos(y)*sin(z),-sin(y);...
cos(x)*sin(z)-sin(x)*sin(y)*cos(z),sin(x)*sin(y)*sin(z)+cos(x)*cos(z),-sin(x)*cos(y);...
cos(x)*sin(y)*cos(z)+sin(x)*sin(z),sin(x)*cos(z)-cos(x)*sin(y)*sin(z),cos(x)*cos(y)];

corners=[-1 -1 -1; -1 1 -1; 1 1 -1; 1 -1 -1; -1 -1 1; -1 1 1; 1 1 1; 1 -1 1]'*dim_nc_tot/2; 
 
corners1=A(theta(ncLabel_1,1),theta(ncLabel_1,2),theta(ncLabel_1,3))*corners;
corners2=A(theta(ncLabel_2,1),theta(ncLabel_2,2),theta(ncLabel_2,3))*corners;

corners1(1,:)=corners1(1,:)+pos(ncLabel_1,1);
corners1(2,:)=corners1(2,:)+pos(ncLabel_1,2);
corners1(3,:)=corners1(3,:)+pos(ncLabel_1,3);

corners2(1,:)=corners2(1,:)+pos(ncLabel_2,1);
corners2(2,:)=corners2(2,:)+pos(ncLabel_2,2);
corners2(3,:)=corners2(3,:)+pos(ncLabel_2,3);

corners1=corners1';
corners2=corners2';

%% axes
axis11=corners1(4,:)-corners1(1,:);
axis12=corners1(2,:)-corners1(1,:);
axis13=corners1(5,:)-corners1(1,:);

axis21=corners2(4,:)-corners2(1,:);
axis22=corners2(2,:)-corners2(1,:);
axis23=corners2(5,:)-corners2(1,:);

uaxis11=axis11/sqrt(axis11*axis11');
uaxis12=axis12/sqrt(axis12*axis12');
uaxis13=axis13/sqrt(axis13*axis13');
uaxis21=axis21/sqrt(axis21*axis21');
uaxis22=axis22/sqrt(axis22*axis22');
uaxis23=axis23/sqrt(axis23*axis23');


diagonal11=corners1(7,:)-corners1(1,:);
diagonal12=corners1(8,:)-corners1(2,:);
diagonal13=corners1(5,:)-corners1(3,:);
diagonal14=corners1(6,:)-corners1(4,:);

diagonal21=corners2(7,:)-corners2(1,:);
diagonal22=corners2(8,:)-corners2(2,:);
diagonal23=corners2(5,:)-corners2(3,:);
diagonal24=corners2(6,:)-corners2(4,:);


%% projection onto axis1 on cube1
proj1=abs(uaxis11*diagonal21');
proj2=abs(uaxis11*diagonal22');
proj3=abs(uaxis11*diagonal23');
proj4=abs(uaxis11*diagonal24');

proj=[proj1,proj2,proj3,proj4];

diagonal=find(proj==max(proj));
diagonal=diagonal(1);

proj=max(proj);


limit=sqrt(axis11*axis11')+proj;


if diagonal==1
    proj1=abs(uaxis11*(corners1(1,:)-corners2(1,:))');
    proj2=abs(uaxis11*(corners1(1,:)-corners2(7,:))');
    proj3=abs(uaxis11*(corners1(4,:)-corners2(1,:))');
    proj4=abs(uaxis11*(corners1(4,:)-corners2(7,:))');
    
    proj=max([proj1,proj2,proj3,proj4]);
    
elseif diagonal==2
    proj1=abs(uaxis11*(corners1(1,:)-corners2(2,:))');
    proj2=abs(uaxis11*(corners1(1,:)-corners2(8,:))');
    proj3=abs(uaxis11*(corners1(4,:)-corners2(2,:))');
    proj4=abs(uaxis11*(corners1(4,:)-corners2(8,:))');
    
    proj=max([proj1,proj2,proj3,proj4]);
    
elseif diagonal==3
    proj1=abs(uaxis11*(corners1(1,:)-corners2(5,:))');
    proj2=abs(uaxis11*(corners1(1,:)-corners2(3,:))');
    proj3=abs(uaxis11*(corners1(4,:)-corners2(5,:))');
    proj4=abs(uaxis11*(corners1(4,:)-corners2(3,:))');
    
    proj=max([proj1,proj2,proj3,proj4]);
    
elseif diagonal==4
    proj1=abs(uaxis11*(corners1(1,:)-corners2(6,:))');
    proj2=abs(uaxis11*(corners1(1,:)-corners2(4,:))');
    proj3=abs(uaxis11*(corners1(4,:)-corners2(6,:))');
    proj4=abs(uaxis11*(corners1(4,:)-corners2(4,:))');
    
    proj=max([proj1,proj2,proj3,proj4]);

end

if proj>=limit
    return
end


%% projection onto axis2 on cube1
proj1=abs(uaxis12*diagonal21');
proj2=abs(uaxis12*diagonal22');
proj3=abs(uaxis12*diagonal23');
proj4=abs(uaxis12*diagonal24');

proj=[proj1,proj2,proj3,proj4];

diagonal=find(proj==max(proj));
diagonal=diagonal(1);

proj=max(proj);


limit=sqrt(axis12*axis12')+proj;


if diagonal==1
    proj1=abs(uaxis12*(corners1(1,:)-corners2(1,:))');
    proj2=abs(uaxis12*(corners1(1,:)-corners2(7,:))');
    proj3=abs(uaxis12*(corners1(2,:)-corners2(1,:))');
    proj4=abs(uaxis12*(corners1(2,:)-corners2(7,:))');
    
    proj=max([proj1,proj2,proj3,proj4]);
    
elseif diagonal==2
    proj1=abs(uaxis12*(corners1(1,:)-corners2(2,:))');
    proj2=abs(uaxis12*(corners1(1,:)-corners2(8,:))');
    proj3=abs(uaxis12*(corners1(2,:)-corners2(2,:))');
    proj4=abs(uaxis12*(corners1(2,:)-corners2(8,:))');
    
    proj=max([proj1,proj2,proj3,proj4]);
    
elseif diagonal==3
    proj1=abs(uaxis12*(corners1(1,:)-corners2(5,:))');
    proj2=abs(uaxis12*(corners1(1,:)-corners2(3,:))');
    proj3=abs(uaxis12*(corners1(2,:)-corners2(5,:))');
    proj4=abs(uaxis12*(corners1(2,:)-corners2(3,:))');
    
    proj=max([proj1,proj2,proj3,proj4]);
    
elseif diagonal==4
    proj1=abs(uaxis12*(corners1(1,:)-corners2(6,:))');
    proj2=abs(uaxis12*(corners1(1,:)-corners2(4,:))');
    proj3=abs(uaxis12*(corners1(2,:)-corners2(6,:))');
    proj4=abs(uaxis12*(corners1(2,:)-corners2(4,:))');
    
    proj=max([proj1,proj2,proj3,proj4]);

end

if proj>=limit
    return
end



%% projection onto axis3 on cube1
proj1=abs(uaxis13*diagonal21');
proj2=abs(uaxis13*diagonal22');
proj3=abs(uaxis13*diagonal23');
proj4=abs(uaxis13*diagonal24');

proj=[proj1,proj2,proj3,proj4];

diagonal=find(proj==max(proj));
diagonal=diagonal(1);

proj=max(proj);


limit=sqrt(axis13*axis13')+proj;


if diagonal==1
    proj1=abs(uaxis13*(corners1(1,:)-corners2(1,:))');
    proj2=abs(uaxis13*(corners1(1,:)-corners2(7,:))');
    proj3=abs(uaxis13*(corners1(5,:)-corners2(1,:))');
    proj4=abs(uaxis13*(corners1(5,:)-corners2(7,:))');
    
    proj=max([proj1,proj2,proj3,proj4]);
    
elseif diagonal==2
    proj1=abs(uaxis13*(corners1(1,:)-corners2(2,:))');
    proj2=abs(uaxis13*(corners1(1,:)-corners2(8,:))');
    proj3=abs(uaxis13*(corners1(5,:)-corners2(2,:))');
    proj4=abs(uaxis13*(corners1(5,:)-corners2(8,:))');
    
    proj=max([proj1,proj2,proj3,proj4]);
    
elseif diagonal==3
    proj1=abs(uaxis13*(corners1(1,:)-corners2(5,:))');
    proj2=abs(uaxis13*(corners1(1,:)-corners2(3,:))');
    proj3=abs(uaxis13*(corners1(5,:)-corners2(5,:))');
    proj4=abs(uaxis13*(corners1(5,:)-corners2(3,:))');
    
    proj=max([proj1,proj2,proj3,proj4]);
    
elseif diagonal==4
    proj1=abs(uaxis13*(corners1(1,:)-corners2(6,:))');
    proj2=abs(uaxis13*(corners1(1,:)-corners2(4,:))');
    proj3=abs(uaxis13*(corners1(5,:)-corners2(6,:))');
    proj4=abs(uaxis13*(corners1(5,:)-corners2(4,:))');
    
    proj=max([proj1,proj2,proj3,proj4]);

end

if proj>=limit
    return
end


%% projection onto axis1 on cube2
proj1=abs(uaxis21*diagonal11');
proj2=abs(uaxis21*diagonal12');
proj3=abs(uaxis21*diagonal13');
proj4=abs(uaxis21*diagonal14');

proj=[proj1,proj2,proj3,proj4];

diagonal=find(proj==max(proj));
diagonal=diagonal(1);

proj=max(proj);


limit=sqrt(axis21*axis21')+proj;


if diagonal==1
    proj1=abs(uaxis21*(corners2(1,:)-corners1(1,:))');
    proj2=abs(uaxis21*(corners2(1,:)-corners1(7,:))');
    proj3=abs(uaxis21*(corners2(4,:)-corners1(1,:))');
    proj4=abs(uaxis21*(corners2(4,:)-corners1(7,:))');
    
    proj=max([proj1,proj2,proj3,proj4]);
    
elseif diagonal==2
    proj1=abs(uaxis21*(corners2(1,:)-corners1(2,:))');
    proj2=abs(uaxis21*(corners2(1,:)-corners1(8,:))');
    proj3=abs(uaxis21*(corners2(4,:)-corners1(2,:))');
    proj4=abs(uaxis21*(corners2(4,:)-corners1(8,:))');
    
    proj=max([proj1,proj2,proj3,proj4]);
    
elseif diagonal==3
    proj1=abs(uaxis21*(corners2(1,:)-corners1(5,:))');
    proj2=abs(uaxis21*(corners2(1,:)-corners1(3,:))');
    proj3=abs(uaxis21*(corners2(4,:)-corners1(5,:))');
    proj4=abs(uaxis21*(corners2(4,:)-corners1(3,:))');
    
    proj=max([proj1,proj2,proj3,proj4]);
    
elseif diagonal==4
    proj1=abs(uaxis21*(corners2(1,:)-corners1(6,:))');
    proj2=abs(uaxis21*(corners2(1,:)-corners1(4,:))');
    proj3=abs(uaxis21*(corners2(4,:)-corners1(6,:))');
    proj4=abs(uaxis21*(corners2(4,:)-corners1(4,:))');
    
    proj=max([proj1,proj2,proj3,proj4]);

end

if proj>=limit
    return
end


%% projection onto axis2 on cube2
proj1=abs(uaxis22*diagonal11');
proj2=abs(uaxis22*diagonal12');
proj3=abs(uaxis22*diagonal13');
proj4=abs(uaxis22*diagonal14');

proj=[proj1,proj2,proj3,proj4];

diagonal=find(proj==max(proj));
diagonal=diagonal(1);

proj=max(proj);


limit=sqrt(axis22*axis22')+proj;


if diagonal==1
    proj1=abs(uaxis22*(corners2(1,:)-corners1(1,:))');
    proj2=abs(uaxis22*(corners2(1,:)-corners1(7,:))');
    proj3=abs(uaxis22*(corners2(2,:)-corners1(1,:))');
    proj4=abs(uaxis22*(corners2(2,:)-corners1(7,:))');
    
    proj=max([proj1,proj2,proj3,proj4]);
    
elseif diagonal==2
    proj1=abs(uaxis22*(corners2(1,:)-corners1(2,:))');
    proj2=abs(uaxis22*(corners2(1,:)-corners1(8,:))');
    proj3=abs(uaxis22*(corners2(2,:)-corners1(2,:))');
    proj4=abs(uaxis22*(corners2(2,:)-corners1(8,:))');
    
    proj=max([proj1,proj2,proj3,proj4]);
    
elseif diagonal==3
    proj1=abs(uaxis22*(corners2(1,:)-corners1(5,:))');
    proj2=abs(uaxis22*(corners2(1,:)-corners1(3,:))');
    proj3=abs(uaxis22*(corners2(2,:)-corners1(5,:))');
    proj4=abs(uaxis22*(corners2(2,:)-corners1(3,:))');
    
    proj=max([proj1,proj2,proj3,proj4]);
    
elseif diagonal==4
    proj1=abs(uaxis22*(corners2(1,:)-corners1(6,:))');
    proj2=abs(uaxis22*(corners2(1,:)-corners1(4,:))');
    proj3=abs(uaxis22*(corners2(2,:)-corners1(6,:))');
    proj4=abs(uaxis22*(corners2(2,:)-corners1(4,:))');
    
    proj=max([proj1,proj2,proj3,proj4]);

end

if proj>=limit
    return
end


%% projection onto axis3 on cube2
proj1=abs(uaxis23*diagonal11');
proj2=abs(uaxis23*diagonal12');
proj3=abs(uaxis23*diagonal13');
proj4=abs(uaxis23*diagonal14');

proj=[proj1,proj2,proj3,proj4];

diagonal=find(proj==max(proj));
diagonal=diagonal(1);

proj=max(proj);


limit=sqrt(axis23*axis23')+proj;


if diagonal==1
    proj1=abs(uaxis23*(corners2(1,:)-corners1(1,:))');
    proj2=abs(uaxis23*(corners2(1,:)-corners1(7,:))');
    proj3=abs(uaxis23*(corners2(5,:)-corners1(1,:))');
    proj4=abs(uaxis23*(corners2(5,:)-corners1(7,:))');
    
    proj=max([proj1,proj2,proj3,proj4]);
    
elseif diagonal==2
    proj1=abs(uaxis23*(corners2(1,:)-corners1(2,:))');
    proj2=abs(uaxis23*(corners2(1,:)-corners1(8,:))');
    proj3=abs(uaxis23*(corners2(5,:)-corners1(2,:))');
    proj4=abs(uaxis23*(corners2(5,:)-corners1(8,:))');
    
    proj=max([proj1,proj2,proj3,proj4]);
    
elseif diagonal==3
    proj1=abs(uaxis23*(corners2(1,:)-corners1(5,:))');
    proj2=abs(uaxis23*(corners2(1,:)-corners1(3,:))');
    proj3=abs(uaxis23*(corners2(5,:)-corners1(5,:))');
    proj4=abs(uaxis23*(corners2(5,:)-corners1(3,:))');
    
    proj=max([proj1,proj2,proj3,proj4]);
    
elseif diagonal==4
    proj1=abs(uaxis23*(corners2(1,:)-corners1(6,:))');
    proj2=abs(uaxis23*(corners2(1,:)-corners1(4,:))');
    proj3=abs(uaxis23*(corners2(5,:)-corners1(6,:))');
    proj4=abs(uaxis23*(corners2(5,:)-corners1(4,:))');
    
    proj=max([proj1,proj2,proj3,proj4]);

end

if proj>=limit
    return
end


%% steric repulsion

 delta=abs(pos(ncLabel_2,:)-pos(ncLabel_1,:));
 
 
 if validate(s,:)==[1 1 1]
   
   if delta(1)>dim_nc_tot/2 && delta(2)< dim_nc_tot/2 && delta(3)<dim_nc_tot/2
     
       pos(ncLabel_1,1)=pos(ncLabel_1,1)-abs(movement(ncLabel_1,1)); %x-coordinate
       pos(ncLabel_2,1)=pos(ncLabel_2,1)+abs(movement(ncLabel_2,1));
       
   elseif delta(1)<dim_nc_tot/2 && delta(2)> dim_nc_tot/2 && delta(3)<dim_nc_tot/2

       pos(ncLabel_1,2)=pos(ncLabel_1,2)-abs(movement(ncLabel_1,2)); %y-coordinate
       pos(ncLabel_2,2)=pos(ncLabel_2,2)+abs(movement(ncLabel_2,2));
       
   elseif delta(1)<dim_nc_tot/2 && delta(2)< dim_nc_tot/2 && delta(3)>dim_nc_tot/2

       pos(ncLabel_1,3)=pos(ncLabel_1,3)-abs(movement(ncLabel_1,3)); %z-coordinate
       pos(ncLabel_2,3)=pos(ncLabel_2,3)+abs(movement(ncLabel_2,3));
       
   elseif delta(1)>dim_nc_tot/2 && delta(2)> dim_nc_tot/2 && delta(3)<dim_nc_tot/2

       pos(ncLabel_1,1)=pos(ncLabel_1,1)-abs(movement(ncLabel_1,1)); %x-coordinate
       pos(ncLabel_2,1)=pos(ncLabel_2,1)+abs(movement(ncLabel_2,1));
       
       pos(ncLabel_1,2)=pos(ncLabel_1,2)-abs(movement(ncLabel_1,2)); %y-coordinate
       pos(ncLabel_2,2)=pos(ncLabel_2,2)+abs(movement(ncLabel_2,2));
       
   elseif delta(1)>dim_nc_tot/2 && delta(2)< dim_nc_tot/2 && delta(3)>dim_nc_tot/2

       pos(ncLabel_1,1)=pos(ncLabel_1,1)-abs(movement(ncLabel_1,1)); %x-coordinate
       pos(ncLabel_2,1)=pos(ncLabel_2,1)+abs(movement(ncLabel_2,1));
       
       pos(ncLabel_1,3)=pos(ncLabel_1,3)-abs(movement(ncLabel_1,3)); %z-coordinate
       pos(ncLabel_2,3)=pos(ncLabel_2,3)+abs(movement(ncLabel_2,3));
       
   elseif delta(1)<dim_nc_tot/2 && delta(2)> dim_nc_tot/2 && delta(3)>dim_nc_tot/2

       pos(ncLabel_1,2)=pos(ncLabel_1,2)-abs(movement(ncLabel_1,2)); %y-coordinate
       pos(ncLabel_2,2)=pos(ncLabel_2,2)+abs(movement(ncLabel_2,2));
       
       pos(ncLabel_1,3)=pos(ncLabel_1,3)-abs(movement(ncLabel_1,3)); %z-coordinate
       pos(ncLabel_2,3)=pos(ncLabel_2,3)+abs(movement(ncLabel_2,3));
       
   else
   
       pos(ncLabel_1,1)=pos(ncLabel_1,1)-abs(movement(ncLabel_1,1)); %x-coordinate
       pos(ncLabel_2,1)=pos(ncLabel_2,1)+abs(movement(ncLabel_2,1));
   
       pos(ncLabel_1,2)=pos(ncLabel_1,2)-abs(movement(ncLabel_1,2)); %y-coordinate
       pos(ncLabel_2,2)=pos(ncLabel_2,2)+abs(movement(ncLabel_2,2));
       
       pos(ncLabel_1,3)=pos(ncLabel_1,3)-abs(movement(ncLabel_1,3)); %z-coordinate
       pos(ncLabel_2,3)=pos(ncLabel_2,3)+abs(movement(ncLabel_2,3));
       
   end
   
      
 elseif validate(s,:)==[1 -1 1]
       
   if delta(1)>dim_nc_tot/2 && delta(2)< dim_nc_tot/2 && delta(3)<dim_nc_tot/2
     
       pos(ncLabel_1,1)=pos(ncLabel_1,1)-abs(movement(ncLabel_1,1)); %x-coordinate
       pos(ncLabel_2,1)=pos(ncLabel_2,1)+abs(movement(ncLabel_2,1));
       
   elseif delta(1)<dim_nc_tot/2 && delta(2)> dim_nc_tot/2 && delta(3)<dim_nc_tot/2

       pos(ncLabel_1,2)=pos(ncLabel_1,2)+abs(movement(ncLabel_1,2)); %y-coordinate
       pos(ncLabel_2,2)=pos(ncLabel_2,2)-abs(movement(ncLabel_2,2));
       
   elseif delta(1)<dim_nc_tot/2 && delta(2)< dim_nc_tot/2 && delta(3)>dim_nc_tot/2

       pos(ncLabel_1,3)=pos(ncLabel_1,3)-abs(movement(ncLabel_1,3)); %z-coordinate
       pos(ncLabel_2,3)=pos(ncLabel_2,3)+abs(movement(ncLabel_2,3));
       
   elseif delta(1)>dim_nc_tot/2 && delta(2)> dim_nc_tot/2 && delta(3)<dim_nc_tot/2

       pos(ncLabel_1,1)=pos(ncLabel_1,1)-abs(movement(ncLabel_1,1)); %x-coordinate
       pos(ncLabel_2,1)=pos(ncLabel_2,1)+abs(movement(ncLabel_2,1));
       
       pos(ncLabel_1,2)=pos(ncLabel_1,2)+abs(movement(ncLabel_1,2)); %y-coordinate
       pos(ncLabel_2,2)=pos(ncLabel_2,2)-abs(movement(ncLabel_2,2));
       
   elseif delta(1)>dim_nc_tot/2 && delta(2)< dim_nc_tot/2 && delta(3)>dim_nc_tot/2

       pos(ncLabel_1,1)=pos(ncLabel_1,1)-abs(movement(ncLabel_1,1)); %x-coordinate
       pos(ncLabel_2,1)=pos(ncLabel_2,1)+abs(movement(ncLabel_2,1));
       
       pos(ncLabel_1,3)=pos(ncLabel_1,3)-abs(movement(ncLabel_1,3)); %z-coordinate
       pos(ncLabel_2,3)=pos(ncLabel_2,3)+abs(movement(ncLabel_2,3));
       
   elseif delta(1)<dim_nc_tot/2 && delta(2)> dim_nc_tot/2 && delta(3)>dim_nc_tot/2

       pos(ncLabel_1,2)=pos(ncLabel_1,2)+abs(movement(ncLabel_1,2)); %y-coordinate
       pos(ncLabel_2,2)=pos(ncLabel_2,2)-abs(movement(ncLabel_2,2));
       
       pos(ncLabel_1,3)=pos(ncLabel_1,3)-abs(movement(ncLabel_1,3)); %z-coordinate
       pos(ncLabel_2,3)=pos(ncLabel_2,3)+abs(movement(ncLabel_2,3));
       
   else
   
       pos(ncLabel_1,1)=pos(ncLabel_1,1)-abs(movement(ncLabel_1,1)); %x-coordinate
       pos(ncLabel_2,1)=pos(ncLabel_2,1)+abs(movement(ncLabel_2,1));
       
       pos(ncLabel_1,2)=pos(ncLabel_1,2)+abs(movement(ncLabel_1,2)); %y-coordinate
       pos(ncLabel_2,2)=pos(ncLabel_2,2)-abs(movement(ncLabel_2,2));
       
       pos(ncLabel_1,3)=pos(ncLabel_1,3)-abs(movement(ncLabel_1,3)); %z-coordinate
       pos(ncLabel_2,3)=pos(ncLabel_2,3)+abs(movement(ncLabel_2,3));
       
   end
   
   
   
 elseif validate(s,:)==[-1 1 1]
   

   if delta(1)>dim_nc_tot/2 && delta(2)< dim_nc_tot/2 && delta(3)<dim_nc_tot/2
     
       pos(ncLabel_1,1)=pos(ncLabel_1,1)+abs(movement(ncLabel_1,1)); %x-coordinate
       pos(ncLabel_2,1)=pos(ncLabel_2,1)-abs(movement(ncLabel_2,1));
       
   elseif delta(1)<dim_nc_tot/2 && delta(2)> dim_nc_tot/2 && delta(3)<dim_nc_tot/2

       pos(ncLabel_1,2)=pos(ncLabel_1,2)-abs(movement(ncLabel_1,2)); %y-coordinate
       pos(ncLabel_2,2)=pos(ncLabel_2,2)+abs(movement(ncLabel_2,2));
       
   elseif delta(1)<dim_nc_tot/2 && delta(2)< dim_nc_tot/2 && delta(3)>dim_nc_tot/2

       pos(ncLabel_1,3)=pos(ncLabel_1,3)-abs(movement(ncLabel_1,3)); %z-coordinate
       pos(ncLabel_2,3)=pos(ncLabel_2,3)+abs(movement(ncLabel_2,3));
       
   elseif delta(1)>dim_nc_tot/2 && delta(2)> dim_nc_tot/2 && delta(3)<dim_nc_tot/2

       pos(ncLabel_1,1)=pos(ncLabel_1,1)+abs(movement(ncLabel_1,1)); %x-coordinate
       pos(ncLabel_2,1)=pos(ncLabel_2,1)-abs(movement(ncLabel_2,1));
       
       pos(ncLabel_1,2)=pos(ncLabel_1,2)-abs(movement(ncLabel_1,2)); %y-coordinate
       pos(ncLabel_2,2)=pos(ncLabel_2,2)+abs(movement(ncLabel_2,2));
       
   elseif delta(1)>dim_nc_tot/2 && delta(2)< dim_nc_tot/2 && delta(3)>dim_nc_tot/2

       pos(ncLabel_1,1)=pos(ncLabel_1,1)+abs(movement(ncLabel_1,1)); %x-coordinate
       pos(ncLabel_2,1)=pos(ncLabel_2,1)-abs(movement(ncLabel_2,1));
       
       pos(ncLabel_1,3)=pos(ncLabel_1,3)-abs(movement(ncLabel_1,3)); %z-coordinate
       pos(ncLabel_2,3)=pos(ncLabel_2,3)+abs(movement(ncLabel_2,3));
       
   elseif delta(1)<dim_nc_tot/2 && delta(2)> dim_nc_tot/2 && delta(3)>dim_nc_tot/2

       pos(ncLabel_1,2)=pos(ncLabel_1,2)-abs(movement(ncLabel_1,2)); %y-coordinate
       pos(ncLabel_2,2)=pos(ncLabel_2,2)+abs(movement(ncLabel_2,2));
       
       pos(ncLabel_1,3)=pos(ncLabel_1,3)-abs(movement(ncLabel_1,3)); %z-coordinate
       pos(ncLabel_2,3)=pos(ncLabel_2,3)+abs(movement(ncLabel_2,3));
       
   else
     
       pos(ncLabel_1,1)=pos(ncLabel_1,1)+abs(movement(ncLabel_1,1)); %x-coordinate
       pos(ncLabel_2,1)=pos(ncLabel_2,1)-abs(movement(ncLabel_2,1));

       pos(ncLabel_1,2)=pos(ncLabel_1,2)-abs(movement(ncLabel_1,2)); %y-coordinate
       pos(ncLabel_2,2)=pos(ncLabel_2,2)+abs(movement(ncLabel_2,2));
       
       pos(ncLabel_1,3)=pos(ncLabel_1,3)-abs(movement(ncLabel_1,3)); %z-coordinate
       pos(ncLabel_2,3)=pos(ncLabel_2,3)+abs(movement(ncLabel_2,3));
       
   end
   
   
   
 elseif validate(s,:)==[-1 -1 1]
  
   if delta(1)>dim_nc_tot/2 && delta(2)< dim_nc_tot/2 && delta(3)<dim_nc_tot/2
     
       pos(ncLabel_1,1)=pos(ncLabel_1,1)+abs(movement(ncLabel_1,1)); %x-coordinate
       pos(ncLabel_2,1)=pos(ncLabel_2,1)-abs(movement(ncLabel_2,1));
       
   elseif delta(1)<dim_nc_tot/2 && delta(2)> dim_nc_tot/2 && delta(3)<dim_nc_tot/2

       pos(ncLabel_1,2)=pos(ncLabel_1,2)+abs(movement(ncLabel_1,2)); %y-coordinate
       pos(ncLabel_2,2)=pos(ncLabel_2,2)-abs(movement(ncLabel_2,2));
       
   elseif delta(1)<dim_nc_tot/2 && delta(2)< dim_nc_tot/2 && delta(3)>dim_nc_tot/2

       pos(ncLabel_1,3)=pos(ncLabel_1,3)-abs(movement(ncLabel_1,3)); %z-coordinate
       pos(ncLabel_2,3)=pos(ncLabel_2,3)+abs(movement(ncLabel_2,3));
       
   elseif delta(1)>dim_nc_tot/2 && delta(2)> dim_nc_tot/2 && delta(3)<dim_nc_tot/2

       pos(ncLabel_1,1)=pos(ncLabel_1,1)+abs(movement(ncLabel_1,1)); %x-coordinate
       pos(ncLabel_2,1)=pos(ncLabel_2,1)-abs(movement(ncLabel_2,1));
       
       pos(ncLabel_1,2)=pos(ncLabel_1,2)+abs(movement(ncLabel_1,2)); %y-coordinate
       pos(ncLabel_2,2)=pos(ncLabel_2,2)-abs(movement(ncLabel_2,2));
       
   elseif delta(1)>dim_nc_tot/2 && delta(2)< dim_nc_tot/2 && delta(3)>dim_nc_tot/2

       pos(ncLabel_1,1)=pos(ncLabel_1,1)+abs(movement(ncLabel_1,1)); %x-coordinate
       pos(ncLabel_2,1)=pos(ncLabel_2,1)-abs(movement(ncLabel_2,1));
       
       pos(ncLabel_1,3)=pos(ncLabel_1,3)-abs(movement(ncLabel_1,3)); %z-coordinate
       pos(ncLabel_2,3)=pos(ncLabel_2,3)+abs(movement(ncLabel_2,3));
       
   elseif delta(1)<dim_nc_tot/2 && delta(2)> dim_nc_tot/2 && delta(3)>dim_nc_tot/2

       pos(ncLabel_1,2)=pos(ncLabel_1,2)+abs(movement(ncLabel_1,2)); %y-coordinate
       pos(ncLabel_2,2)=pos(ncLabel_2,2)-abs(movement(ncLabel_2,2));
       
       pos(ncLabel_1,3)=pos(ncLabel_1,3)-abs(movement(ncLabel_1,3)); %z-coordinate
       pos(ncLabel_2,3)=pos(ncLabel_2,3)+abs(movement(ncLabel_2,3));
         
     else
         
       pos(ncLabel_1,1)=pos(ncLabel_1,1)+abs(movement(ncLabel_1,1)); %x-coordinate
       pos(ncLabel_2,1)=pos(ncLabel_2,1)-abs(movement(ncLabel_2,1));

       pos(ncLabel_1,2)=pos(ncLabel_1,2)+abs(movement(ncLabel_1,2)); %y-coordinate
       pos(ncLabel_2,2)=pos(ncLabel_2,2)-abs(movement(ncLabel_2,2));
       
       pos(ncLabel_1,3)=pos(ncLabel_1,3)-abs(movement(ncLabel_1,3)); %z-coordinate
       pos(ncLabel_2,3)=pos(ncLabel_2,3)+abs(movement(ncLabel_2,3));
       
     end
     
     
 elseif validate(s,:)==[1 1 -1]
   
   if delta(1)>dim_nc_tot/2 && delta(2)< dim_nc_tot/2 && delta(3)<dim_nc_tot/2
     
       pos(ncLabel_1,1)=pos(ncLabel_1,1)-abs(movement(ncLabel_1,1)); %x-coordinate
       pos(ncLabel_2,1)=pos(ncLabel_2,1)+abs(movement(ncLabel_2,1));
       
   elseif delta(1)<dim_nc_tot/2 && delta(2)> dim_nc_tot/2 && delta(3)<dim_nc_tot/2

       pos(ncLabel_1,2)=pos(ncLabel_1,2)-abs(movement(ncLabel_1,2)); %y-coordinate
       pos(ncLabel_2,2)=pos(ncLabel_2,2)+abs(movement(ncLabel_2,2));
       
   elseif delta(1)<dim_nc_tot/2 && delta(2)< dim_nc_tot/2 && delta(3)>dim_nc_tot/2

       pos(ncLabel_1,3)=pos(ncLabel_1,3)+abs(movement(ncLabel_1,3)); %z-coordinate
       pos(ncLabel_2,3)=pos(ncLabel_2,3)-abs(movement(ncLabel_2,3));
       
   elseif delta(1)>dim_nc_tot/2 && delta(2)> dim_nc_tot/2 && delta(3)<dim_nc_tot/2

       pos(ncLabel_1,1)=pos(ncLabel_1,1)-abs(movement(ncLabel_1,1)); %x-coordinate
       pos(ncLabel_2,1)=pos(ncLabel_2,1)+abs(movement(ncLabel_2,1));
       
       pos(ncLabel_1,2)=pos(ncLabel_1,2)-abs(movement(ncLabel_1,2)); %y-coordinate
       pos(ncLabel_2,2)=pos(ncLabel_2,2)+abs(movement(ncLabel_2,2));
       
   elseif delta(1)>dim_nc_tot/2 && delta(2)< dim_nc_tot/2 && delta(3)>dim_nc_tot/2

       pos(ncLabel_1,1)=pos(ncLabel_1,1)-abs(movement(ncLabel_1,1)); %x-coordinate
       pos(ncLabel_2,1)=pos(ncLabel_2,1)+abs(movement(ncLabel_2,1));
       
       pos(ncLabel_1,3)=pos(ncLabel_1,3)+abs(movement(ncLabel_1,3)); %z-coordinate
       pos(ncLabel_2,3)=pos(ncLabel_2,3)-abs(movement(ncLabel_2,3));
       
   elseif delta(1)<dim_nc_tot/2 && delta(2)> dim_nc_tot/2 && delta(3)>dim_nc_tot/2

       pos(ncLabel_1,2)=pos(ncLabel_1,2)-abs(movement(ncLabel_1,2)); %y-coordinate
       pos(ncLabel_2,2)=pos(ncLabel_2,2)+abs(movement(ncLabel_2,2));
       
       pos(ncLabel_1,3)=pos(ncLabel_1,3)+abs(movement(ncLabel_1,3)); %z-coordinate
       pos(ncLabel_2,3)=pos(ncLabel_2,3)-abs(movement(ncLabel_2,3));
       
   else
   
       pos(ncLabel_1,1)=pos(ncLabel_1,1)-abs(movement(ncLabel_1,1)); %x-coordinate
       pos(ncLabel_2,1)=pos(ncLabel_2,1)+abs(movement(ncLabel_2,1));
   
       pos(ncLabel_1,2)=pos(ncLabel_1,2)-abs(movement(ncLabel_1,2)); %y-coordinate
       pos(ncLabel_2,2)=pos(ncLabel_2,2)+abs(movement(ncLabel_2,2));
       
       pos(ncLabel_1,3)=pos(ncLabel_1,3)+abs(movement(ncLabel_1,3)); %z-coordinate
       pos(ncLabel_2,3)=pos(ncLabel_2,3)-abs(movement(ncLabel_2,3));
       
   end
   
      
 elseif validate(s,:)==[1 -1 -1]
   
   if delta(1)>dim_nc_tot/2 && delta(2)< dim_nc_tot/2 && delta(3)<dim_nc_tot/2
     
       pos(ncLabel_1,1)=pos(ncLabel_1,1)-abs(movement(ncLabel_1,1)); %x-coordinate
       pos(ncLabel_2,1)=pos(ncLabel_2,1)+abs(movement(ncLabel_2,1));
       
   elseif delta(1)<dim_nc_tot/2 && delta(2)> dim_nc_tot/2 && delta(3)<dim_nc_tot/2

       pos(ncLabel_1,2)=pos(ncLabel_1,2)+abs(movement(ncLabel_1,2)); %y-coordinate
       pos(ncLabel_2,2)=pos(ncLabel_2,2)-abs(movement(ncLabel_2,2));
       
   elseif delta(1)<dim_nc_tot/2 && delta(2)< dim_nc_tot/2 && delta(3)>dim_nc_tot/2

       pos(ncLabel_1,3)=pos(ncLabel_1,3)+abs(movement(ncLabel_1,3)); %z-coordinate
       pos(ncLabel_2,3)=pos(ncLabel_2,3)-abs(movement(ncLabel_2,3));
       
   elseif delta(1)>dim_nc_tot/2 && delta(2)> dim_nc_tot/2 && delta(3)<dim_nc_tot/2

       pos(ncLabel_1,1)=pos(ncLabel_1,1)-abs(movement(ncLabel_1,1)); %x-coordinate
       pos(ncLabel_2,1)=pos(ncLabel_2,1)+abs(movement(ncLabel_2,1));
       
       pos(ncLabel_1,2)=pos(ncLabel_1,2)+abs(movement(ncLabel_1,2)); %y-coordinate
       pos(ncLabel_2,2)=pos(ncLabel_2,2)-abs(movement(ncLabel_2,2));
       
   elseif delta(1)>dim_nc_tot/2 && delta(2)< dim_nc_tot/2 && delta(3)>dim_nc_tot/2

       pos(ncLabel_1,1)=pos(ncLabel_1,1)-abs(movement(ncLabel_1,1)); %x-coordinate
       pos(ncLabel_2,1)=pos(ncLabel_2,1)+abs(movement(ncLabel_2,1));
       
       pos(ncLabel_1,3)=pos(ncLabel_1,3)+abs(movement(ncLabel_1,3)); %z-coordinate
       pos(ncLabel_2,3)=pos(ncLabel_2,3)-abs(movement(ncLabel_2,3));
       
   elseif delta(1)<dim_nc_tot/2 && delta(2)> dim_nc_tot/2 && delta(3)>dim_nc_tot/2

       pos(ncLabel_1,2)=pos(ncLabel_1,2)+abs(movement(ncLabel_1,2)); %y-coordinate
       pos(ncLabel_2,2)=pos(ncLabel_2,2)-abs(movement(ncLabel_2,2));
       
       pos(ncLabel_1,3)=pos(ncLabel_1,3)+abs(movement(ncLabel_1,3)); %z-coordinate
       pos(ncLabel_2,3)=pos(ncLabel_2,3)-abs(movement(ncLabel_2,3));
       
   else
   
       pos(ncLabel_1,1)=pos(ncLabel_1,1)-abs(movement(ncLabel_1,1)); %x-coordinate
       pos(ncLabel_2,1)=pos(ncLabel_2,1)+abs(movement(ncLabel_2,1));
       
       pos(ncLabel_1,2)=pos(ncLabel_1,2)+abs(movement(ncLabel_1,2)); %y-coordinate
       pos(ncLabel_2,2)=pos(ncLabel_2,2)-abs(movement(ncLabel_2,2));
       
       pos(ncLabel_1,3)=pos(ncLabel_1,3)+abs(movement(ncLabel_1,3)); %z-coordinate
       pos(ncLabel_2,3)=pos(ncLabel_2,3)-abs(movement(ncLabel_2,3));
       
   end
   
   
   
 elseif validate(s,:)==[-1 1 -1]
   
   if delta(1)>dim_nc_tot/2 && delta(2)< dim_nc_tot/2 && delta(3)<dim_nc_tot/2
     
       pos(ncLabel_1,1)=pos(ncLabel_1,1)+abs(movement(ncLabel_1,1)); %x-coordinate
       pos(ncLabel_2,1)=pos(ncLabel_2,1)-abs(movement(ncLabel_2,1));
       
   elseif delta(1)<dim_nc_tot/2 && delta(2)> dim_nc_tot/2 && delta(3)<dim_nc_tot/2

       pos(ncLabel_1,2)=pos(ncLabel_1,2)-abs(movement(ncLabel_1,2)); %y-coordinate
       pos(ncLabel_2,2)=pos(ncLabel_2,2)+abs(movement(ncLabel_2,2));
       
   elseif delta(1)<dim_nc_tot/2 && delta(2)< dim_nc_tot/2 && delta(3)>dim_nc_tot/2

       pos(ncLabel_1,3)=pos(ncLabel_1,3)+abs(movement(ncLabel_1,3)); %z-coordinate
       pos(ncLabel_2,3)=pos(ncLabel_2,3)-abs(movement(ncLabel_2,3));
       
   elseif delta(1)>dim_nc_tot/2 && delta(2)> dim_nc_tot/2 && delta(3)<dim_nc_tot/2

       pos(ncLabel_1,1)=pos(ncLabel_1,1)+abs(movement(ncLabel_1,1)); %x-coordinate
       pos(ncLabel_2,1)=pos(ncLabel_2,1)-abs(movement(ncLabel_2,1));
       
       pos(ncLabel_1,2)=pos(ncLabel_1,2)-abs(movement(ncLabel_1,2)); %y-coordinate
       pos(ncLabel_2,2)=pos(ncLabel_2,2)+abs(movement(ncLabel_2,2));
       
   elseif delta(1)>dim_nc_tot/2 && delta(2)< dim_nc_tot/2 && delta(3)>dim_nc_tot/2

       pos(ncLabel_1,1)=pos(ncLabel_1,1)+abs(movement(ncLabel_1,1)); %x-coordinate
       pos(ncLabel_2,1)=pos(ncLabel_2,1)-abs(movement(ncLabel_2,1));
       
       pos(ncLabel_1,3)=pos(ncLabel_1,3)+abs(movement(ncLabel_1,3)); %z-coordinate
       pos(ncLabel_2,3)=pos(ncLabel_2,3)-abs(movement(ncLabel_2,3));
       
   elseif delta(1)<dim_nc_tot/2 && delta(2)> dim_nc_tot/2 && delta(3)>dim_nc_tot/2

       pos(ncLabel_1,2)=pos(ncLabel_1,2)-abs(movement(ncLabel_1,2)); %y-coordinate
       pos(ncLabel_2,2)=pos(ncLabel_2,2)+abs(movement(ncLabel_2,2));
       
       pos(ncLabel_1,3)=pos(ncLabel_1,3)+abs(movement(ncLabel_1,3)); %z-coordinate
       pos(ncLabel_2,3)=pos(ncLabel_2,3)-abs(movement(ncLabel_2,3));
       
   else
     
       pos(ncLabel_1,1)=pos(ncLabel_1,1)+abs(movement(ncLabel_1,1)); %x-coordinate
       pos(ncLabel_2,1)=pos(ncLabel_2,1)-abs(movement(ncLabel_2,1));

       pos(ncLabel_1,2)=pos(ncLabel_1,2)-abs(movement(ncLabel_1,2)); %y-coordinate
       pos(ncLabel_2,2)=pos(ncLabel_2,2)+abs(movement(ncLabel_2,2));
       
       pos(ncLabel_1,3)=pos(ncLabel_1,3)+abs(movement(ncLabel_1,3)); %z-coordinate
       pos(ncLabel_2,3)=pos(ncLabel_2,3)-abs(movement(ncLabel_2,3));
       
   end
   
   
   
 else
  
   if delta(1)>dim_nc_tot/2 && delta(2)< dim_nc_tot/2 && delta(3)<dim_nc_tot/2
     
       pos(ncLabel_1,1)=pos(ncLabel_1,1)+abs(movement(ncLabel_1,1)); %x-coordinate
       pos(ncLabel_2,1)=pos(ncLabel_2,1)-abs(movement(ncLabel_2,1));
       
   elseif delta(1)<dim_nc_tot/2 && delta(2)> dim_nc_tot/2 && delta(3)<dim_nc_tot/2

       pos(ncLabel_1,2)=pos(ncLabel_1,2)+abs(movement(ncLabel_1,2)); %y-coordinate
       pos(ncLabel_2,2)=pos(ncLabel_2,2)-abs(movement(ncLabel_2,2));
       
   elseif delta(1)<dim_nc_tot/2 && delta(2)< dim_nc_tot/2 && delta(3)>dim_nc_tot/2

       pos(ncLabel_1,3)=pos(ncLabel_1,3)+abs(movement(ncLabel_1,3)); %z-coordinate
       pos(ncLabel_2,3)=pos(ncLabel_2,3)-abs(movement(ncLabel_2,3));
       
   elseif delta(1)>dim_nc_tot/2 && delta(2)> dim_nc_tot/2 && delta(3)<dim_nc_tot/2

       pos(ncLabel_1,1)=pos(ncLabel_1,1)+abs(movement(ncLabel_1,1)); %x-coordinate
       pos(ncLabel_2,1)=pos(ncLabel_2,1)-abs(movement(ncLabel_2,1));
       
       pos(ncLabel_1,2)=pos(ncLabel_1,2)+abs(movement(ncLabel_1,2)); %y-coordinate
       pos(ncLabel_2,2)=pos(ncLabel_2,2)-abs(movement(ncLabel_2,2));
       
   elseif delta(1)>dim_nc_tot/2 && delta(2)< dim_nc_tot/2 && delta(3)>dim_nc_tot/2

       pos(ncLabel_1,1)=pos(ncLabel_1,1)+abs(movement(ncLabel_1,1)); %x-coordinate
       pos(ncLabel_2,1)=pos(ncLabel_2,1)-abs(movement(ncLabel_2,1));
       
       pos(ncLabel_1,3)=pos(ncLabel_1,3)+abs(movement(ncLabel_1,3)); %z-coordinate
       pos(ncLabel_2,3)=pos(ncLabel_2,3)-abs(movement(ncLabel_2,3));
       
   elseif delta(1)<dim_nc_tot/2 && delta(2)> dim_nc_tot/2 && delta(3)>dim_nc_tot/2

       pos(ncLabel_1,2)=pos(ncLabel_1,2)+abs(movement(ncLabel_1,2)); %y-coordinate
       pos(ncLabel_2,2)=pos(ncLabel_2,2)-abs(movement(ncLabel_2,2));
       
       pos(ncLabel_1,3)=pos(ncLabel_1,3)+abs(movement(ncLabel_1,3)); %z-coordinate
       pos(ncLabel_2,3)=pos(ncLabel_2,3)-abs(movement(ncLabel_2,3));
         
     else
         
       pos(ncLabel_1,1)=pos(ncLabel_1,1)+abs(movement(ncLabel_1,1)); %x-coordinate
       pos(ncLabel_2,1)=pos(ncLabel_2,1)-abs(movement(ncLabel_2,1));

       pos(ncLabel_1,2)=pos(ncLabel_1,2)+abs(movement(ncLabel_1,2)); %y-coordinate
       pos(ncLabel_2,2)=pos(ncLabel_2,2)-abs(movement(ncLabel_2,2));
       
       pos(ncLabel_1,3)=pos(ncLabel_1,3)+abs(movement(ncLabel_1,3)); %z-coordinate
       pos(ncLabel_2,3)=pos(ncLabel_2,3)-abs(movement(ncLabel_2,3));
       
     end
   
 
 end



end